Page MenuHomePhabricator

CentralNotice banners should exist in their own namespace (stop using the MediaWiki namespace)
Open, NormalPublic

Description


Version: unspecified
Severity: normal

Details

Reference
bz31595

Event Timeline

bzimport raised the priority of this task from to Normal.Nov 21 2014, 11:51 PM
bzimport set Reference to bz31595.
bzimport added a subscriber: Unknown Object (MLST).

This was mentioned to my Tim Starling a while back and I didn't add a description hoping he'd add it in his own words since I didn't have full details about what he was envisioning.

Confirmed. The banner bodies are namespaced under "MediaWiki:Centralnotice-template-", and message fields are under "MediaWiki:Centralnotice-(templatename)-", but there could be collisions with builtin CN messages.

Not sure that will ever become a problem, it would take some very odd banner naming to cause a collision.

thewub.wiki wrote:

*** Bug 42488 has been marked as a duplicate of this bug. ***

Hope that the new system can have a better fallback chain.

Could you clarify the fallback chain issue Liangent?

(In reply to comment #5)

Could you clarify the fallback chain issue Liangent?

Currently CN fetches message with wfMessage() which doesn't really go through the fallback chain (like zh-cn -> zh-hans -> zh -> en) when getting a message from database (instead it uses zh-cn -> en). This has been logged as a bug in i18n system but was never fixed. If CN turns to its own message fetching code it can avoid this issue of wfMessage().

(In reply to comment #5)

Could you clarify the fallback chain issue Liangent?

Direct effect: stewards have to populate /zh-cn, /zh-hk, /zh-mo, /zh-my, /zh-sg, /zh-tw, /zh-hans, /zh-hant and /zh subpages (9 in total) instead of simple /zh-hans and /zh-hant (2 in total).

(In reply to comment #6)

This has been logged as a bug in i18n system but was never fixed.

It's bug 1495. Sorry for spamming with comments.

wmf.amgine3691 wrote:

Wouldn't it be better to fix the known bug in i18n than replicate functionality?

(In reply to comment #9)

Wouldn't it be better to fix the known bug in i18n than replicate
functionality?

First, fixing that issue is not the goal of this new-namespace design. It's just something "we should notice or remember" when implementing this new namespace. Second, that issue may be not so easy to fix (otherwise it shouldn't be living there for such a long time...) Anyway you're welcome to fix that bug. :)

Copying the stats from bug 42488 comment 0:

The CentralNotice extension currently uses the MediaWiki namespace for storage.
Today, Meta-Wiki has 53,320 pages in the MediaWiki namespace; of those, 51,147
begin with "Centralnotice".

mwalker wrote:

(In reply to comment #6)

Currently CN fetches message with wfMessage() which doesn't really go through
the fallback chain (like zh-cn -> zh-hans -> zh -> en) when getting a message
from database (instead it uses zh-cn -> en).

Not that this really helps, but I have about five i18n patches for CentralNotice in a holding pattern until after the fundraiser. One of which addresses this exact issue. I looked at fixing the core i18n code and though doable it was a more significant investment of time than I wanted to expend at the time I wrote my patch. Seeing as I'm waiting till January to deploy this patch set anyways I can probably go and fix the bug in core.

  • As to moving things to their own namespace. With the deployment of the CN i18n stuff we will in fact have our own namespace but it will be as a scratch space for the translate extension. Once it's been marked as translated/approved we move it into MW again. I kept it this way for backwards compatibility reasons (mostly that I didn't want to have to write code to look in multiple locations for the banner.)
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptNov 13 2015, 6:04 PM
Base added a subscriber: Base.Sep 4 2017, 3:42 PM
awight removed a subscriber: awight.Mar 21 2019, 4:06 PM